package com.itko.lisa.ext.util;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.commons.beanutils.BeanUtils;

import com.itko.lisa.test.TestExec;
import com.itko.util.ParameterList;

/**
 * Helper methods for working with Lisa properties.
 * 
 * @author <a href="mailto:luther@itko.com">Luther Birdzell</a>
 */
public class LisaPropertyHelper
{
    private static Logger log = Logger.getLogger(LisaPropertyHelper.class.getName());

    /**
     * 
     * 
     * @param params
     * @param testExec
     * @param propertyName
     * @return the value of the specified LISA property
     */
    public static String getLisaPropertyValue(ParameterList params,
                                              TestExec testExec,
                                              String propertyName)
    {
        String propertyValue = null;

        try
        {
            propertyValue = testExec.parseInState(BeanUtils.getProperty(params,
                                                                        propertyName));
        }
        catch ( Exception e )
        {
            log.log(Level.SEVERE, e.getMessage(), e);
            throw new RuntimeException(e.getMessage(), e);
        }

        return propertyValue;
    }

    /**
     * 
     * 
     * @param testExec
     * @param propertyValue
     * @return the value of the specified LISA property
     */
    public static String getLisaPropertyValue(TestExec testExec,
                                              String propertyValue)
    {
        String parsedValue = null;

        try
        {
            propertyValue = testExec.parseInState(propertyValue);
        }
        catch ( Exception e )
        {
            log.log(Level.SEVERE, e.getMessage(), e);
            throw new RuntimeException(e.getMessage(), e);
        }

        return parsedValue;
    }
}
