package com.itko.lisa.ext.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

public class TestCaseUtil {

	private final static Logger logger = Logger.getLogger(TestCaseUtil.class);

	public static boolean renameFile(String source, String target) {
		boolean rtn = true;
		File src = new File(source);
		if (!src.renameTo(new File(target))) {
			logger.error("Unable to rename file source:" + source
					+ ", target: " + target);
			rtn = false;
		}
		return rtn;
	}

	public static void writeStringToFile(String fileName, String dataString,
			boolean append) {
		fileName = fileName.replace("\\", "/");
		fileName = fileName.replace("/\\", "/");
		fileName = fileName.replace("//", "/");
		// logger.debug("writeStringToFile output to: " + fileName);
		if (fileName == null) {
			throw new IllegalArgumentException("missing fileName");
		}
		if (dataString == null) {
			throw new IllegalArgumentException("missing String");
		}
		Pattern p = Pattern.compile("\\{\\{");
		Matcher m = p.matcher(dataString);

		BufferedWriter output;
		try {
			String baseDir = fileName.substring(0, fileName.lastIndexOf("/"));
			// logger.debug("baseDir:" + baseDir);

			File tempFile = new File(baseDir);
			tempFile.mkdir();
			output = new BufferedWriter(new FileWriter(fileName, append));
			output.write(dataString);
			output.flush();
			output.close();
		} catch (IOException ex) {
			logger.error("Error while trying to write response xml to "
					+ fileName, ex);
		}
		// logger.info("writeStringToFile success to: " + fileName);

		if (m.find()) {
			logger.error("found {{ in, fileName:" + fileName
					+ " request xml unparsed");
		}

	}

	/**
	 * used by test case java script step to write xml response string to a
	 * file.
	 * 
	 * @param fileName
	 * @param dataString
	 */
	public static void writeStringToFile(String fileName, String dataString) {
		writeStringToFile(fileName, dataString, false);
	}

	public static String getTrimmedValue(String input, int max) {
		String rtn = StringUtils.rightPad(input, max, " ");
		if (rtn.length() > max) {
			rtn = StringUtils.right(rtn, max);
		}
		return rtn;
	}


}
